// Program #5: A High/Low Guessing Game (Procedural Programming style)

// Open App B print-out: use p 1120-1121
// Read the code execution to fill-in the blanks and the comments

import java.util.*;
import java.io.*;


public class Prog4 {     //OFF-BY-ONE error
  
  private static final String SCORES_FILE = "scores.txt";
  private static final String GUESS_PROMPT = "Enter your guess:";
  
  //Class variable used to generate random numbers
  private static Random rand = new Random();
 
  
  private static int findRank(Scanner fInput, int score) {
  	
  	int rank = 0;
  	
  	while (fInput.hasNextLine()) {
  		String line = fInput.nextLine();
  		
  		Scanner parseTokens = new Scanner(line);
  		String name = parseTokens.next();
  		int value = parseTokens.nextInt();
  		
  		if (value > score)
  			rank++;
  	}
  	
  	return rank;
  }


  // Display the prompt and keep asking until guess is an integer
  // post: return the player int number
  private static int getInt(Scanner console, String prompt) {
    System.out.print(prompt);
    
    while (!console.hasNextInt()) {
      console.next();
      System.out.println("Not an integer; try again.");
      System.out.print(prompt);
    }
    return console.nextInt();
  }
  
    
  // Prints ______________ on guess
  public static void printGuessFeedback(int number, int guess) {
    
    if (guess < number)
      System.out.println("Your guess is too low!");
    else if (guess > number)
      System.out.println("Your guess is too high!");
  }
  
  
  // _____________________________________________
  // post: guess is between 0 and 99
  public static int getGuess(Scanner console) {
    
    int guess = getInt(console, GUESS_PROMPT);
    while (guess < 0 || guess >= 100) {
      System.out.println("Out of range; try again.");
      guess = getInt(console, "Enter your guess?: ");
    }
    
    return guess;
  }
 
 
  // 
  public static String giveIntro(Scanner console) {
    System.out.print("Please enter your name: ");
    String name = console.nextLine();
    System.out.println("\nHello "+ name +"!\nTry to guess my");
    System.out.println("number (0-99), and I'll tell you if");
    System.out.println("you're too low or high.");
    System.out.println();
  
    return name;
  }
  

  public static void main(String[] args) throws FileNotFoundException { 
    
    Scanner console = new Scanner(System.in);
    String name = giveIntro(console);
    
    // pick a random number from 0 to 99 inclusive
    int number = rand.nextInt(100);
    
    //
    int guess = -1;
    int numGuesses = 0;
    
    //// give hints until correct guess is reached
    while (guess != number) {
     guess = getGuess(console);
     printGuessFeedback(number, guess);
     numGuesses++;
    }
    
    System.out.println("Nice job " + name + "!!");
    System.out.println("You got it right in " + numGuesses + " tries.");
    
    Scanner fileInput = new Scanner(new File(SCORES_FILE));
    findRank(fileInput, numGuesses);
  }

}
